<template>
  <b-col lg="7" class="pl-0 pr-0">
    <b-container fluid class="light-bg h-100 pl-0 pr-0">
      <b-nav tabs class="">
          <b-nav-item v-for="option in options" :key="option.value" :active="option.isSelected" @click="handleClick(option.value)">
            {{option.text}}
          </b-nav-item>
      </b-nav>
      <b-container fluid class="p-2">
        <bar-chart :chartData="chartData" :options="chartOptions"></bar-chart>
      </b-container>
    </b-container>
  </b-col>
</template>

<script>
import BarChart from './charts/BarChart.vue'

export default {

  name: 'LiveComparativeMeasures',

  components: {
    BarChart
  },

  data: function () {
    return {
      // List of tabs (all sensors except rain)
      options: this.$store.state.allCapteurs.filter(e => e.value !== 'rain').map((e, i) => {
        return { text: e.text, value: e.value, unit: e.unit, isSelected: i === 0 }
      })
    }
  },

  computed: {
    chartData () {
      return {
        labels: this.$store.state.allSondes.map((e) => { return e.text }),
        datasets: this.$store.state.liveComparativeMeasures.map((e, i) => {
          return {
            label: e.type,
            data: e.data,
            backgroundColor: this.$store.state.colorPalette[i]
          }
        })
      }
    },
    chartOptions () {
      return {
        responsive: true,
        maintainAspectRatio: false,
        scales: {
          xAxes: [{ barPercentage: 0.15, stacked: true }],
          yAxes: [{
            stacked: true,
            ticks: {
              beginAtZero: true,
              // adding the corresponding unit to the Y axis
              callback: value => value + ' ' + this.options.find(e => e.isSelected).unit
            }
          }]
        }
      }
    }
  },

  mounted () {
    // get all sondes value for the selected sensor
    this.$store.dispatch('getLiveComparativeMeasures', this.options.find(e => e.isSelected).value)
  },

  methods: {
    handleClick (e) {
      // get all sondes value for the selected sensor
      this.$store.dispatch('getLiveComparativeMeasures', e)
      // change isSelected attribute to match the selected tab
      this.options.forEach(elem => {
        if (elem.value !== e) elem.isSelected = false
        else elem.isSelected = true
      })
    }

  }
}
</script>

<style scoped>

</style>
